function _defineProperty(e, t, a) {
    return t in e ? Object.defineProperty(e, t, {
        value: a,
        enumerable: !0,
        configurable: !0,
        writable: !0
    }) : e[t] = a, e;
}

Component({
    properties: {
        rpxRatio: {
            type: Number,
            value: 1
        },
        colorData: {
            type: Object,
            value: {}
        }
    },
    data: {
        hueData: {
            colorStopRed: 255,
            colorStopGreen: 0,
            colorStopBlue: 0
        },
        pickerData: {
            x: 0,
            y: 480,
            red: 0,
            green: 0,
            blue: 0,
            hex: "#000000"
        },
        barY: 0,
        top: 0,
        left: 0,
        scrollTop: 0,
        scrollLeft: 0
    },
    lifetimes: {
        attached: function() {
            this.setData({
                hueData: this.data.colorData.hueData,
                pickerData: this.data.colorData.pickerData,
                barY: this.data.colorData.barY
            });
        },
        ready: function() {
            var t = this, e = wx.createSelectorQuery().in(this);
            e.select("#wrapper").boundingClientRect(), e.selectViewport().scrollOffset(), e.exec(function(e) {
                t.setData({
                    top: e[0].top,
                    left: e[0].left,
                    scrollTop: e[1].scrollTop,
                    scrollLeft: e[1].scrollLeft
                });
            });
        }
    },
    methods: {
        _chooseColor: function(e) {
            var t, a = (e.changedTouches[0].pageX - this.data.left - this.data.scrollLeft) / this.data.rpxRatio, r = (e.changedTouches[0].pageY - this.data.top - this.data.scrollTop) / this.data.rpxRatio;
            a = (a = 480 < a ? 480 : a) < 0 ? 0 : a, r = (r = 480 < r ? 480 : r) < 0 ? 0 : r, 
            this.setData((_defineProperty(t = {}, "pickerData.x", a), _defineProperty(t, "pickerData.y", r), 
            t)), this._changeColor(a, r);
        },
        _changeBar: function(e) {
            var t = (e.changedTouches[0].pageY - this.data.top - this.data.scrollTop) / this.data.rpxRatio;
            t = (t = 490 < t ? 490 : t) < 0 ? 0 : t, this.setData({
                barY: t
            }), this._changeHue(t);
        },
        _changeColor: function(e, t) {
            var a, r = this.data.hueData.colorStopRed, o = this.data.hueData.colorStopGreen, i = this.data.hueData.colorStopBlue, h = [ this.data.pickerData.red, this.data.pickerData.green, this.data.pickerData.blue ], n = h[0], p = h[1], c = h[2];
            if (255 === r) {
                var l = 255 - e * ((255 - o) / 480), d = 255 - e * ((255 - i) / 480);
                n = 255, p = Math.round(o < l ? l : o), c = Math.round(i < d ? d : i);
            }
            if (255 === o) {
                var u = 255 - e * ((255 - r) / 480), s = 255 - e * ((255 - i) / 480);
                n = Math.round(r < u ? u : r), p = 255, c = Math.round(i < s ? s : i);
            }
            if (255 === i) {
                var f = 255 - e * ((255 - r) / 480), D = 255 - e * ((255 - o) / 480);
                n = Math.round(r < f ? f : r), p = Math.round(o < D ? D : o), c = 255;
            }
            var _ = t * (n / 480), y = t * (p / 480), P = t * (c / 480), S = this._rgbToHex(n - _, p - y, c - P);
            this.setData((_defineProperty(a = {}, "pickerData.red", Math.round(n - _)), _defineProperty(a, "pickerData.green", Math.round(p - y)), 
            _defineProperty(a, "pickerData.blue", Math.round(c - P)), _defineProperty(a, "pickerData.hex", S), 
            a)), this.triggerEvent("changecolor", {
                colorData: this.data
            });
        },
        _changeHue: function(e) {
            if (e < 81.67) {
                var t, a = 255 < e / .32 ? 255 : e / .32;
                this.setData((_defineProperty(t = {}, "hueData.colorStopRed", 255), _defineProperty(t, "hueData.colorStopGreen", Math.round(a)), 
                _defineProperty(t, "hueData.colorStopBlue", 0), t));
            }
            if (81.67 <= e && e < 163.34) {
                var r, o = 255 < (e - 81.67) / .32 ? 255 : (e - 81.67) / .32;
                this.setData((_defineProperty(r = {}, "hueData.colorStopRed", 255 - Math.round(o)), 
                _defineProperty(r, "hueData.colorStopGreen", 255), _defineProperty(r, "hueData.colorStopBlue", 0), 
                r));
            }
            if (163.34 <= e && e < 245.01) {
                var i, h = 255 < (e - 163.34) / .32 ? 255 : (e - 163.34) / .32;
                this.setData((_defineProperty(i = {}, "hueData.colorStopRed", 0), _defineProperty(i, "hueData.colorStopGreen", 255), 
                _defineProperty(i, "hueData.colorStopBlue", Math.round(h)), i));
            }
            if (245.01 <= e && e < 326.68) {
                var n, p = 255 < (e - 245.01) / .32 ? 255 : (e - 245.01) / .32;
                this.setData((_defineProperty(n = {}, "hueData.colorStopRed", 0), _defineProperty(n, "hueData.colorStopGreen", 255 - Math.round(p)), 
                _defineProperty(n, "hueData.colorStopBlue", 255), n));
            }
            if (326.68 <= e && e < 408.35) {
                var c, l = 255 < (e - 326.68) / .32 ? 255 : (e - 326.68) / .32;
                this.setData((_defineProperty(c = {}, "hueData.colorStopRed", Math.round(l)), _defineProperty(c, "hueData.colorStopGreen", 0), 
                _defineProperty(c, "hueData.colorStopBlue", 255), c));
            }
            if (408.35 <= e) {
                var d, u = 255 < (e - 408.35) / .32 ? 255 : (e - 408.35) / .32;
                this.setData((_defineProperty(d = {}, "hueData.colorStopRed", 255), _defineProperty(d, "hueData.colorStopGreen", 0), 
                _defineProperty(d, "hueData.colorStopBlue", 255 - Math.round(u)), d));
            }
            this._changeColor(this.data.pickerData.x, this.data.pickerData.y);
        },
        _rgbToHex: function(e, t, a) {
            var r = (e << 16 | t << 8 | a).toString(16);
            return r.length < 6 && (r = "" + "0".repeat(6 - r.length) + r), "0" == r && (r = "000000"), 
            "#" + r;
        }
    }
});