var _util = require("../../utils/util"), _util2 = _interopRequireDefault(_util);

function _interopRequireDefault(e) {
    return e && e.__esModule ? e : {
        default: e
    };
}

var qqmapsdk, App = getApp(), QQMapWX = require("../../helpers/qqmap-wx-jssdk.min.js");

Component({
    properties: {
        type: {
            type: String,
            value: "text"
        },
        label: {
            type: String,
            value: "标题"
        },
        isLabel: {
            type: Boolean,
            value: !0
        },
        isRequire: {
            type: Boolean,
            value: !1
        },
        isLine: {
            type: Boolean,
            value: !1
        },
        isEdit: {
            type: Boolean,
            value: !0
        },
        isChange: {
            type: Boolean,
            value: !0
        },
        isAddress: {
            type: Boolean,
            value: !1
        },
        isPhone: {
            type: Boolean,
            value: !1
        },
        isWdzt: {
            type: Boolean,
            value: !1
        },
        addresstip: {
            type: String,
            value: "请点击选择地址"
        },
        value: {
            type: String,
            value: ""
        },
        placeholder: {
            type: String,
            value: "请输入内容"
        },
        className: {
            type: String,
            value: ""
        },
        readonly: {
            type: String,
            value: ""
        },
        description: {
            type: String,
            value: ""
        },
        latitude: {
            type: Number,
            value: -1
        },
        longitude: {
            type: Number,
            value: -1
        },
        borderclz: {
            type: String,
            value: ""
        },
        isMask: {
            type: Boolean,
            value: !1
        }
    },
    data: {
        fileBasePath: App.siteInfo.fileBasePath,
        autoFocus: !1
    },
    lifetimes: {
        attached: function() {
            this.data.isEdit && this.setData({
                readonly: 'readonly="readonly"'
            });
        }
    },
    methods: {
        chooseWdzt: function() {
            App.navigateTo("wdzt");
        },
        chooseLocation: function(e) {
            var i = this;
            if (App.Tools.isTextEmpty(App.globalData.pz.mapkey)) return _util2.default.showModal("请配置地图密钥"), 
            !1;
            var t = App.globalData.pz.mapkey ? App.globalData.pz.mapkey : "LV5BZ-6C26W-5LNRY-OBQEY-XS42O-WUBYM";
            qqmapsdk = new QQMapWX({
                key: t
            }), wx.getLocation({
                type: "gcj02",
                altitude: !0,
                isHighAccuracy: !0,
                success: function(a) {
                    qqmapsdk.reverseGeocoder({
                        location: {
                            latitude: a.latitude,
                            longitude: a.longitude
                        },
                        success: function(e) {
                            var t = e.result.formatted_addresses.recommend;
                            i.triggerEvent("change", {
                                name: i.data.name,
                                address: t,
                                latitude: a.latitude,
                                longitude: a.longitude
                            });
                        },
                        fail: function(e) {
                            console.error(e), _util2.default.showModal(e.message);
                        },
                        complete: function(e) {
                            console.log(e);
                        }
                    });
                },
                error: function() {
                    _util2.default.checkPermission("userLocation", function() {
                        i.chooseLocation(e);
                    }, "需要获取您的地理位置，请确认授权");
                }
            });
        },
        inputBlur: function(e) {
            var t = App.Tools.hasSensitiveWords(e.detail.value), a = e.detail.value;
            t && (this.triggerEvent("toast", "标题包含敏感词，已经自动处理为*，请重新编辑"), a = App.Tools.replaceAll(e.detail.value, t)), 
            this.setData({
                value: a
            }), this.data.isAddress ? -1 == this.data.longitude || 0 == this.data.longitude ? this.triggerEvent("change", {
                address: a
            }) : this.triggerEvent("change", {
                name: this.data.name,
                address: a,
                latitude: this.data.latitude,
                longitude: this.data.longitude
            }) : this.triggerEvent("change", this.data.value);
        },
        clearValue: function(e) {
            this.setData({
                value: ""
            }), this.triggerEvent("change", this.data.value);
        },
        isMaskTatp: function() {},
        getPhoneNumber: function(e) {
            var t = this;
            "getPhoneNumber:ok" != e.detail.errMsg ? wx.showModal({
                title: "异常提示",
                content: "个人微信息号或非认证企业号没有权限。" + e.detail.errMsg
            }) : App.HttpService.getData({
                encryptedData: e.detail.encryptedData,
                iv: e.detail.iv,
                session_key: App.Session.getSessionid(),
                login: "1",
                user: "1"
            }, "/data/getphonenumber.html").then(function(e) {
                e.phoneNumber ? (t.setData({
                    value: e.phoneNumber
                }), t.triggerEvent("change", t.data.value)) : t.triggerEvent("toast", e.message);
            });
        }
    }
});